diff -r 6b3ac7e864ba source/simulation2/system/InterfaceScripted.h
--- a/source/simulation2/system/InterfaceScripted.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/simulation2/system/InterfaceScripted.h	Thu Nov 04 14:52:01 2010 +0000
@@ -45,38 +45,38 @@
 
 #define DEFINE_INTERFACE_METHOD_0(scriptname, rettype, classname, methodname) \
 	{ scriptname, \
-		reinterpret_cast<JSNative>(static_cast<JSFastNative>(ScriptInterface::callMethod<rettype, &class_##classname, classname, &classname::methodname>)), \
+		ScriptInterface::callMethod<rettype, &class_##classname, classname, &classname::methodname>, \
 		0, \
-		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT|JSFUN_FAST_NATIVE, 0 },
+		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT },
 
 #define DEFINE_INTERFACE_METHOD_1(scriptname, rettype, classname, methodname, arg1) \
 	{ scriptname, \
-		reinterpret_cast<JSNative>(static_cast<JSFastNative>(ScriptInterface::callMethod<rettype, arg1, &class_##classname, classname, &classname::methodname>)), \
+		ScriptInterface::callMethod<rettype, arg1, &class_##classname, classname, &classname::methodname>, \
 		1, \
-		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT|JSFUN_FAST_NATIVE, 0 },
+		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT },
 
 #define DEFINE_INTERFACE_METHOD_2(scriptname, rettype, classname, methodname, arg1, arg2) \
 	{ scriptname, \
-		reinterpret_cast<JSNative>(static_cast<JSFastNative>(ScriptInterface::callMethod<rettype, arg1, arg2, &class_##classname, classname, &classname::methodname>)), \
+		ScriptInterface::callMethod<rettype, arg1, arg2, &class_##classname, classname, &classname::methodname>, \
 		2, \
-		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT|JSFUN_FAST_NATIVE, 0 },
+		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT },
 
 #define DEFINE_INTERFACE_METHOD_3(scriptname, rettype, classname, methodname, arg1, arg2, arg3) \
 	{ scriptname, \
-		reinterpret_cast<JSNative>(static_cast<JSFastNative>(ScriptInterface::callMethod<rettype, arg1, arg2, arg3, &class_##classname, classname, &classname::methodname>)), \
+		ScriptInterface::callMethod<rettype, arg1, arg2, arg3, &class_##classname, classname, &classname::methodname>, \
 		3, \
-		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT|JSFUN_FAST_NATIVE, 0 },
+		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT },
 
 #define DEFINE_INTERFACE_METHOD_4(scriptname, rettype, classname, methodname, arg1, arg2, arg3, arg4) \
 	{ scriptname, \
-		reinterpret_cast<JSNative>(static_cast<JSFastNative>(ScriptInterface::callMethod<rettype, arg1, arg2, arg3, arg4, &class_##classname, classname, &classname::methodname>)), \
+		ScriptInterface::callMethod<rettype, arg1, arg2, arg3, arg4, &class_##classname, classname, &classname::methodname>, \
 		4, \
-		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT|JSFUN_FAST_NATIVE, 0 },
+		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT },
 
 #define DEFINE_INTERFACE_METHOD_5(scriptname, rettype, classname, methodname, arg1, arg2, arg3, arg4, arg5) \
 	{ scriptname, \
-		reinterpret_cast<JSNative>(static_cast<JSFastNative>(ScriptInterface::callMethod<rettype, arg1, arg2, arg3, arg4, arg5, &class_##classname, classname, &classname::methodname>)), \
+		ScriptInterface::callMethod<rettype, arg1, arg2, arg3, arg4, arg5, &class_##classname, classname, &classname::methodname>, \
 		5, \
-		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT|JSFUN_FAST_NATIVE, 0 },
+		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT },
 
 #endif // INCLUDED_INTERFACE_SCRIPTED
diff -r 6b3ac7e864ba source/simulation2/tests/test_ComponentManager.h
--- a/source/simulation2/tests/test_ComponentManager.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/simulation2/tests/test_ComponentManager.h	Thu Nov 04 14:52:01 2010 +0000
@@ -325,6 +325,7 @@
 	{
 		CSimContext context;
 		CComponentManager man(context);
+		ScriptTestSetup(man.m_ScriptInterface);
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-entityid.js"));
 
@@ -334,10 +335,8 @@
 		man.AddComponent(ent1, man.LookupCID("TestScript1A"), noParam);
 		man.AddComponent(ent2, man.LookupCID("TestScript1A"), noParam);
 
-		TestLogger log;
 		TS_ASSERT_EQUALS(static_cast<ICmpTest1*> (man.QueryInterface(ent1, IID_Test1))->GetX(), (int)ent1);
 		TS_ASSERT_EQUALS(static_cast<ICmpTest1*> (man.QueryInterface(ent2, IID_Test1))->GetX(), (int)ent2);
-		TS_ASSERT_WSTR_CONTAINS(log.GetOutput(), L"this.entity is read-only");
 	}
 
 	void test_script_QueryInterface()
@@ -632,6 +631,7 @@
 	{
 		CSimContext context;
 		CComponentManager man(context);
+		ScriptTestSetup(man.m_ScriptInterface);
 		man.LoadComponentTypes();
 		TS_ASSERT(man.LoadScript(L"simulation/components/test-serialize.js"));
 
diff -r 6b3ac7e864ba source/simulation2/tests/test_Serializer.h
--- a/source/simulation2/tests/test_Serializer.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/simulation2/tests/test_Serializer.h	Thu Nov 04 14:52:01 2010 +0000
@@ -372,17 +372,17 @@
 		const char stream[] = "\x02" // SCRIPT_TYPE_ARRAY
 					"\x04\0\0\0" // num props
 					"\x01\0\0\0" "0\0" // "0"
-					"\x05" "\x00\0\0\xC0" // SCRIPT_TYPE_INT -1073741824 (JS_INT_MIN)
+					"\x05" "\0\0\0\x80" // SCRIPT_TYPE_INT -2147483648 (JS_INT_MIN)
 					"\x01\0\0\0" "1\0" // "1"
-					"\x06" "\0\0\x40\0\0\0\xD0\xC1" // SCRIPT_TYPE_DOUBLE -1073741825 (JS_INT_MIN-1)
+					"\x06" "\0\0\x20\0\0\0\xE0\xC1" // SCRIPT_TYPE_DOUBLE -2147483649 (JS_INT_MIN-1)
 					"\x01\0\0\0" "2\0" // "2"
-					"\x05" "\xFF\xFF\xFF\x3F" // SCRIPT_TYPE_INT 1073741823
+					"\x05" "\xFF\xFF\xFF\x7F" // SCRIPT_TYPE_INT 2147483647 (JS_INT_MAX)
 					"\x01\0\0\0" "3\0" // "3"
-					"\x06" "\0\0\0\0\0\0\xD0\x41" // SCRIPT_TYPE_DOUBLE 1073741824
+					"\x06" "\0\0\0\0\0\0\xE0\x41" // SCRIPT_TYPE_DOUBLE 2147483648 (JS_INT_MAX+1)
 		;
 
-		helper_script_roundtrip("numbers", "[-1073741824, -1073741825, 1.073741823e+9, 1073741824]",
-				"[-1073741824, -1073741825, 1073741823, 1073741824]", sizeof(stream) - 1, stream);
+		helper_script_roundtrip("numbers", "[-2147483648, -2147483649, 2.147483647e+9, 2147483648]",
+				"[-2147483648, -2147483649, 2147483647, 2147483648]", sizeof(stream) - 1, stream);
 	}
 
 	void test_script_exceptions()
diff -r 6b3ac7e864ba source/sound/JSI_Sound.cpp
--- a/source/sound/JSI_Sound.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/sound/JSI_Sound.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -28,21 +28,14 @@
 {
 	m_Handle = snd_open(g_VFS, pathname);
 
-	// special-case to avoid throwing exceptions if quickstart has
-	// disabled sound: set a flag queried by Construct; the object will
-	// then immediately be freed.
-	if (m_Handle == ERR::AGAIN)
+	// if open failed, we still have to return a valid non-null object to
+	// the script, so just reset the handle to 0 so all subsequent method
+	// calls will do nothing
+	if (m_Handle < 0)
 	{
-		m_SoundDisabled = true;
+		m_Handle = 0;
 		return;
 	}
-	m_SoundDisabled = false;
-
-	// if open failed, raise an exception - it's the only way to
-	// report errors, since we're in the ctor and don't want to move
-	// the open call elsewhere (by requiring an explicit open() call).
-	if (m_Handle < 0)
-		throw std::exception(); // caught by JSI_Sound::Construct.
 
 	(void)snd_set_pos(m_Handle, 0,0,0, true);
 }
@@ -190,35 +183,17 @@
 	return "[object Sound: " + CStr(h_filename(m_Handle).string()) + "]";
 }
 
-JSBool JSI_Sound::Construct(JSContext* cx, JSObject* UNUSED(obj), uintN argc, jsval* argv, jsval* rval)
+JSBool JSI_Sound::Construct(JSContext* cx, uintN argc, jsval* vp)
 {
-	debug_assert(argc >= 1); // FIXME
+	JSU_REQUIRE_MIN_PARAMS(1);
+
 	CStrW filename;
-	if (! ToPrimitive<CStrW>(cx, argv[0], filename))
+	if (! ToPrimitive<CStrW>(cx, JS_ARGV(cx, vp)[0], filename))
 		return JS_FALSE;
 
-	try
-	{
-		JSI_Sound* newObject = new JSI_Sound(filename);
-
-		// somewhat of a hack to avoid throwing exceptions if
-		// sound was disabled due to quickstart. see JSI_Sound().
-		if (newObject->m_SoundDisabled)
-		{
-			delete newObject;
-			*rval = JSVAL_NULL;
-			return JS_TRUE;
-		}
-
-		newObject->m_EngineOwned = false;
-		*rval = OBJECT_TO_JSVAL(newObject->GetScript());
-	}
-	catch (std::exception)
-	{
-		// failed, but this can happen easily enough that we don't want to
-		// return JS_FALSE (since that stops the script).
-		*rval = JSVAL_NULL;
-	}
+	JSI_Sound* newObject = new JSI_Sound(filename);
+	newObject->m_EngineOwned = false;
+	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(newObject->GetScript()));
 
 	return JS_TRUE;
 }
diff -r 6b3ac7e864ba source/sound/JSI_Sound.h
--- a/source/sound/JSI_Sound.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/sound/JSI_Sound.h	Thu Nov 04 14:52:01 2010 +0000
@@ -48,34 +48,31 @@
 
 	// Script-bound functions
 
-	CStr ToString( JSContext* cx, uintN argc, jsval* argv );
+	CStr ToString(JSContext* cx, uintN argc, jsval* argv);
 
 	// start playing the sound (one-shot).
 	// it will automatically be freed when done.
-	bool Play( JSContext* cx, uintN argc, jsval* argv );
+	bool Play(JSContext* cx, uintN argc, jsval* argv);
 
 	// request the sound be played until free() is called. returns immediately.
-	bool Loop( JSContext* cx, uintN argc, jsval* argv );
+	bool Loop(JSContext* cx, uintN argc, jsval* argv);
 
 	// stop sound if currently playing and free resources.
 	// doesn't need to be called unless played via loop() -
 	// sounds are freed automatically when done playing.
-	bool Free( JSContext* cx, uintN argc, jsval* argv );
+	bool Free(JSContext* cx, uintN argc, jsval* argv);
 
-	bool SetGain( JSContext* cx, uintN argc, jsval* argv );
+	bool SetGain(JSContext* cx, uintN argc, jsval* argv);
 
-	bool SetPitch( JSContext* cx, uintN argc, jsval* argv );
+	bool SetPitch(JSContext* cx, uintN argc, jsval* argv);
 
-	bool SetPosition( JSContext* cx, uintN argc, jsval* argv );
+	bool SetPosition(JSContext* cx, uintN argc, jsval* argv);
 
-	bool Fade ( JSContext* cx, uintN argc, jsval* argv );
+	bool Fade(JSContext* cx, uintN argc, jsval* argv);
 
-	static JSBool Construct( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
+	static JSBool Construct(JSContext* cx, uintN argc, jsval* vp);
 
 	static void ScriptingInit();
-
-private:
-	bool m_SoundDisabled;	// see constructor and JSI_Sound::Construct
 };
 
 #endif	// #ifndef INCLUDED_JSI_SOUND
